/********************************************************************

noiseclock: sumarize time of mp3 and other sound formats
Copyright (C) 2004 Jack Chatterton <chattj AT postreal.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.

*********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include "dirstack.h"
#include "utilities.h"

/* You might notice that we neither malloc nor free anything here. This is
 because we assume that whatever is calling this singleton knows it 
 intimately and will do memory management with what is inserted and
 removed. This code can be reused (ha!) as long as that is kept in mind */

struct dir_entry *top = NULL;
int size = 0;

void create_dirstack() {
	top = NULL;
	size = 0;
}

void dirpush(dir_entry *dir) {
	dir->next = top;
	top = dir;
	size++;
}

/* HAZARD: this will happily return null structures all day long */
dir_entry *dirpop() {
	struct dir_entry *new;
	new = NULL;
	if(top != NULL) {
		new = top;
		top = top->next;
		size--;
	}
	return(new);
}
	
int getsize() {
	return size;
}

/* Are we going to need this mofo? I dunno. For now it is broken. */
/*
void flip_dirstack() {
	int i;
	int tempsize = getsize();
	struct dir_entry *newtop;
	struct dir_entry *builder;
	newtop = NULL;
	builder = (struct dir_entry *) safe_malloc(sizeof(struct dir_entry));
	for(i = 1; i <= tempsize; i++) {
		builder = dirpop();
		-* add one to size because it doesn't really change for these
		 stack pops *-
		size++;
		builder->next = newtop;
		newtop = builder;
	}
	top = newtop;
	safe_free(builder);
}
*/
